package com.winhc.task.util;

import com.alibaba.fastjson.JSONObject;

import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.time.temporal.ChronoUnit;
import java.util.Calendar;
import java.util.Locale;
import java.util.Random;
import java.util.function.Function;

/**
 * @Author: XuJiakai
 * @Date: 2020/7/20 13:48
 * @Description:
 */
public class DateUtils {
    private static final DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd")
            .withLocale(Locale.CHINA)
            .withZone(ZoneId.systemDefault());
    private static final DateTimeFormatter ymd_df = DateTimeFormatter.ofPattern("yyyyMMdd")
            .withLocale(Locale.CHINA)
            .withZone(ZoneId.systemDefault());

    public static String getYesterday() {
        Instant instant = Instant.now().minus(1, ChronoUnit.DAYS);
        return df.format(instant);
    }

    public static String getYesterday_ymd() {
        Instant instant = Instant.now().minus(1, ChronoUnit.DAYS);
        return ymd_df.format(instant);
    }

    public static String getMinusDay(Integer i) {
        Instant instant = Instant.now().minus(i, ChronoUnit.DAYS);
        return df.format(instant);
    }

    public static String randomDate(Integer year_start, Integer year_end, Integer month_start, Integer month_end) {
        Random random = new Random();
        int year = random.nextInt(year_end - year_start + 1) + year_start;
        Calendar c = Calendar.getInstance();
        c.set(Calendar.YEAR, year);
        int month = random.nextInt(month_end - month_start + 1) + month_start;
        int day = random.nextInt(c.getActualMaximum(Calendar.DAY_OF_MONTH)) + 1;
        c.set(Calendar.MONTH, month - 1);
        c.set(Calendar.DATE, day);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(c.getTime());
    }


    public static void main(String[] args) {
        System.out.println(randomDate(2023, 2023, 3, 6));
        System.out.println(getYesterday());
        System.out.println(getYesterday_ymd());
        System.out.println(getMinusDay(30));
    }
}
