package com.winhc.task;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONPath;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;
import java.util.*;

@SpringBootTest
public class EsTest {
    @Autowired
    com.winhc.task.job.EsIndexJobs esIndexJobs;

    @Test
    public void start() throws IOException {
        esIndexJobs.start();
    }

    @Test
    public void start2() throws IOException {
        esIndexJobs.start2();
    }

//    static List<String> l = Arrays.asList("company_env_punishment", "company_own_tax", "company_land_announcement", "company_land_publicity",
//            "company_equity_pledge", "company_tax_contravention", "company_punishment_info_creditchina", "company_license_creditchina"
//            , "company_land_transfer", "company_equity_pledge_holder", "company_land_mortgage");

    static List<String> l = Arrays.asList("company_license_entpub","company_public_announcement");

    @Test
    public void start3() {
        l.forEach(x -> {
            try {
                createNewIndex(x);
            } catch (IOException ioException) {
                ioException.printStackTrace();
            }
        });
    }

    private void createNewIndex(String tn) throws IOException {
        String res = esIndexJobs.action("GET", "winhc_index_" + tn, null);
        System.out.println(res);
        ArrayList<JSONObject> e1 = (ArrayList) JSONPath.eval(JSON.parse(res), "$..mappings");
        JSONArray s1 = (JSONArray) JSONPath.eval(JSON.parse(res), "$..settings.index.number_of_shards");
        JSONArray s2 = (JSONArray) JSONPath.eval(JSON.parse(res), "$..settings.index.number_of_replicas");
        JSONObject j = new JSONObject();
        j.put("mappings", e1.get(0));
        j.fluentPut("settings",
                new JSONObject()
                        .fluentPut("index",
                                new JSONObject()
                                        .fluentPut("number_of_shards", s1.get(0))
                                        .fluentPut("number_of_replicas", s2.get(0))));
        String r = JSONObject.toJSONString(j);
        System.out.println(r);
        String index = "winhc_index_rt_" + tn + "_v1";
        String alias = "winhc_index_rt_" + tn;
        String r2 = esIndexJobs.action("PUT", index, r);
        System.out.println(r2);
        esIndexJobs.addOrRemoveAliases(index, alias, "add");

    }

    @Test
    public void start4() {
        String s = "POST _reindex?slices=auto&refresh&wait_for_completion=false\n" +
                "{\n" +
                "  \"source\": {\n" +
                "    \"index\": \"$source\"\n" +
                "  },\n" +
                "  \"dest\": {\n" +
                "    \"index\": \"$dest\"\n" +
                "  }\n" +
                "}";
        l.forEach(x -> {
            String source = "winhc_index_" + x;
            String dest = "winhc_index_rt_" + x;
            String res = s.replaceAll("\\$source", source).replaceAll("\\$dest", dest);
            System.out.println(res);
        });

    }

    @Test
    public void start5() {
        Random random = new Random();
        int year = random.nextInt(11) + 2010;

        Calendar c = Calendar.getInstance();
        c.set(Calendar.YEAR, year);

        int month = random.nextInt(12) + 1;
        int day = random.nextInt(c.getActualMaximum(Calendar.DAY_OF_MONTH)) + 1;

        c.set(Calendar.MONTH, month - 1);
        c.set(Calendar.DATE, day);

        System.out.println(c.getTime());
    }
}